
#include <vector>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

#define NUM_OPERARIAS 100

class Formiga
{
    protected:

        static int comidas;

    public:

        Formiga()
        {
            comidas = 0;

            // Em funo da funo main, 'comidas' teria que ser zerado na criao da cada
            // instncia de Formiga ou, seno, de alguma forma na criao de cada instncia
            // de Jardim via um dado setComidas em Formiga apropriado para tal (por exemplo).
        }

        virtual ~Formiga()
        {
            comidas = 0;
        }

        void operator++()
        {
            comidas++;
            //cout << "Comidas incrementadas para: " << comidas << endl;
        }

        static const int getComidas()
        {
            return comidas;
        }
};

int Formiga::comidas = 0;


class Operaria : public Formiga
{
    private:
        bool exploradora;
        static int feromonio;

    public:
        // Para funo srand e rand vide:
        // https://www.tutorialspoint.com/c_standard_library/c_function_srand.htm
        Operaria()
            : Formiga(),
            exploradora(false)
        {
            feromonio = 0;

            time_t t;

            srand((unsigned) time(&t));
            int result = rand()%2;

            result ? exploradora = true : exploradora = false;

        }

        ~Operaria()
        {
            feromonio = 0;
        }

        void operator++()
        {
            if (exploradora)
            {
                feromonio++;
                //cout << "Feromonio incrementado para: " << feromonio << endl;
            }
        }

        const bool getExploradora() const { return exploradora; }

        static const int getFeromonio()  { return feromonio; }
};

int Operaria::feromonio = 0;


class Formigueiro;

class Rainha : public Formiga
{
    private:
        Formigueiro* pLar;

    public:
        Rainha() :
            Formiga(), pLar(NULL)
        {
            //pLar = NULL;
        }

        ~Rainha()
        {
            pLar = NULL;
        }

        void setPLar(Formigueiro* pF)
        {
            pLar = pF;
        }

        void nascerOperarias(); // Implementao ocorre depois da classe Formigueiro, j que a usa
};

class Formigueiro
{
    private:
        vector<Operaria*> formigal;
        vector<Operaria*>::iterator itFormigal;
        Rainha rainha;

    public:
            Formigueiro():
                formigal(),
                itFormigal(),
                rainha()
            {
                 formigal.clear();

                 rainha.setPLar(this);

                 rainha.nascerOperarias();
            }

            ~Formigueiro()
            {
                /*int tam = (int)formigal.size();

                for (int i = 0; i < tam; i++)
                {
                    if ( formigal[i] )
                    {
                        delete formigal[i];
                        formigal[i] = NULL;
                    }
                }*/

                /*itFormigal = formigal.begin();
                while (itFormigal != formigal.end())
                {
                    if  ( *itFormigal != NULL )
                    {
                        delete *itFormigal;
                        *itFormigal = NULL;
                    }
                    itFormigal++;
                }*/

                inicio();

                while ( fim() )
                {
                    Operaria*  pf = NULL;

                    pf = (Operaria*)atual();

                    if (pf)
                    {
                        delete pf;
                        pf = NULL;
                    }

                    proximo();
                }


                formigal.clear();

            }

            void inserir(Operaria* pOp)
            {
               if ( pOp )
               {
                    formigal.push_back(pOp);
               }
               else
               {
                    cout << "Ponteiro Operaria pOP Nulo em Formigueiro!" << endl;
               }
            }

            void inicio ()
            {
                itFormigal = formigal.begin();
            }

            void proximo ()
            {
                if ( itFormigal != formigal.end() )
                {
                    itFormigal++;

                }
                else
                {
                    cout << "Fim do vector formigal" << endl;
                }
            }

            Formiga* atual() const
            {
                return static_cast<Formiga*>(*itFormigal);
            }

            const bool fim() const
            {
                if (formigal.end() == itFormigal)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            const bool vivo() const
            {
                int tam = (int)formigal.size();
                //cout << "Tamanho do formigal eh: " << tam << endl; getchar();

                if ( Formiga::getComidas() >= (10*tam) )
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
    };

    // Agora sim a implementao do mtodo 'nascerOperarias' de 'Rainha'
    void Rainha::nascerOperarias()
    {
        Operaria* pOp = NULL;

        for (int i = 0; i < NUM_OPERARIAS; i++)
        {
            pOp = new Operaria();

            if ( (pLar) && (pOp) )
            {
                pLar->inserir(pOp);
            }
            else
            {
                if (pOp)
                {
                   cout << "Lar/formigueio pLar nulo em Rainha." << endl;
                }
                else
                {
                   cout << "Operaria pOp nulo em Rainha." << endl;
                }
            }
        }
    }


class Jardim
{
    private:
        Formigueiro formigueiro;
        int quant_folhas;

    public:
        Jardim(const int quant_f = 0):
            formigueiro(),
            quant_folhas(quant_f)
        {
            if (quant_folhas  < 0)
            {
                quant_folhas = 0;
            }

            executar();
        }

        ~Jardim()
        {
        }

        void exploracao()
        {
            Operaria* pOp = NULL;

            formigueiro.inicio();

            while( !formigueiro.fim() )
            {
                pOp =  static_cast<Operaria*>(formigueiro.atual());

                if (pOp)
                {
                    if ( pOp->getExploradora() )
                    {
                        for (int i = 0; i < quant_folhas; i++)
                        {
                            pOp->operator++();
                        }
                    }
                }
                else
                {
                        cout << "Ponteiro nulo na explorao!" << endl;
                }

                formigueiro.proximo();
            }

            formigueiro.inicio();
        }

        void carreira()
        {
            //Operaria*   pOp     = NULL;
            Formiga*    pF      = NULL;

            formigueiro.inicio();

            for (int i = 0; i < Operaria::getFeromonio(); i++)
            {
                pF  = formigueiro.atual();

                if (pF)
                {
                    pF->operator++();
                }
                else
                {
                    cout << "Ponteiro nulo na carreira!" << endl;
                }

                formigueiro.proximo();

                if (formigueiro.fim())
                {
                    formigueiro.inicio();
                }
            }

            formigueiro.inicio();
        }

        void executar()
        {
            exploracao();
            carreira();

            if ( formigueiro.vivo() )
            {
                cout << "Formigueiro vivo." << endl;
            }
            else
            {
                cout << "Formigueiro no vivo."  << endl;
            }
        }
};

int main ()
{

   for (int i = 0; i < 20; i++)
   {
      cout << "Numero de folhas: " << i << endl;

      Jardim jardim ( i );

      cout << endl;
   }

   return 0;
}
